Gecode::Search::Seq::Probe< Tracer > Class Template Reference

Probe engine for LDS More...

`#include <lds.hh>`

## Classes

class | Node
| Node in the search tree for LDS More...

## Public Member Functions

| Probe (const Options &opt)
| Initialize.
void | init (Space *s)
| Initialize with space s.
void | reset (Space *s, unsigned int d)
| Reset with space s and discrepancy d.
Statistics | statistics (void) const
| Return statistics.
| ~Probe (void)
| Destructor.
Space * | next (const Options &o)
| Search for next solution
bool | done (void) const
| Test whether probing is done.
Public Member Functions inherited from Gecode::Search::Worker
| Worker (void)
| Initialize.
void | start (void)
| Reset stop information.
bool | stop (const Options &o)
| Check whether engine must be stopped.
bool | stopped (void) const
| Check whether engine has been stopped.
void | reset (unsigned long int d=0)
| Reset statistics with root depth d.
void | stack_depth (unsigned long int d)
| Record stack depth d.
unsigned long int | steal_depth (unsigned long int d) const
| Return steal depth.
Public Member Functions inherited from Gecode::Search::Statistics
| Statistics (void)
| Initialize.
void | reset (void)
| Reset.
Statistics | operator+ (const Statistics &s)
| Return sum with s.
Statistics & | operator+= (const Statistics &s)
| Increment by statistics s.
Public Member Functions inherited from Gecode::StatusStatistics
| StatusStatistics (void)
| Initialize.
void | reset (void)
| Reset information.
StatusStatistics | operator+ (const StatusStatistics &s)
| Return sum with s.
StatusStatistics & | operator+= (const StatusStatistics &s)
| Increment by statistics s.

## Protected Types

typedef Tracer::ID | ID
| Node identity type.

## Protected Attributes

Tracer | tracer
| Search tracer.
Support::DynamicStack< Node, Heap > | ds
| Stack storing current path in search tree
Space * | cur
| Current space.
unsigned int | d
| Current discrepancy.
bool | exhausted
| Whether entire search space has been exhausted.
Protected Attributes inherited from Gecode::Search::Worker
bool | _stopped
| Whether engine has been stopped.
unsigned long int | root_depth
| Depth of root node (for work stealing).

## Additional Inherited Members

Public Attributes inherited from Gecode::Search::Statistics
unsigned long int | fail
| Number of failed nodes in search tree.
unsigned long int | node
| Number of nodes expanded.
unsigned long int | depth
| Maximum depth of search stack.
unsigned long int | restart
| Number of restarts.
unsigned long int | nogood
| Number of no-goods posted.
Public Attributes inherited from Gecode::StatusStatistics
unsigned long int | propagate
| Number of propagator executions.

## Detailed Description

template<class Tracer>
class Gecode::Search::Seq::Probe< Tracer >

Probe engine for LDS

Definition at line 45 of file lds.hh.

## Member Typedef Documentation

## ID

template<class Tracer>

typedef Tracer::ID Gecode::Search::Seq::Probe< Tracer >::ID

protected

Node identity type.

Definition at line 48 of file lds.hh.

## Constructor & Destructor Documentation

## Probe()

template<class Tracer>

Gecode::Search::Seq::Probe< Tracer >::Probe | ( | const Options & | opt | ) |

inline

Initialize.

Definition at line 92 of file lds.hpp.

## ~Probe()

template<class Tracer>

Gecode::Search::Seq::Probe< Tracer >::~Probe | ( | void |  | ) |

inline

Destructor.

Definition at line 133 of file lds.hpp.

## Member Function Documentation

## init()

template<class Tracer>

void Gecode::Search::Seq::Probe< Tracer >::init | ( | Space * | s | ) |

inline

Initialize with space s.

Definition at line 100 of file lds.hpp.

## reset()

template<class Tracer>

void Gecode::Search::Seq::Probe< Tracer >::reset | ( | Space * | s,
|  | unsigned int | d )

inline

Reset with space s and discrepancy d.

Definition at line 108 of file lds.hpp.

## statistics()

template<class Tracer>

Statistics Gecode::Search::Seq::Probe< Tracer >::statistics | ( | void |  | ) | const

inline

Return statistics.

Definition at line 121 of file lds.hpp.

## next()

template<class Tracer>

Space * Gecode::Search::Seq::Probe< Tracer >::next | ( | const Options & | o | ) |

inline

Search for next solution

Definition at line 142 of file lds.hpp.

## done()

template<class Tracer>

bool Gecode::Search::Seq::Probe< Tracer >::done | ( | void |  | ) | const

inline

Test whether probing is done.

Definition at line 127 of file lds.hpp.

## Member Data Documentation

## tracer

template<class Tracer>

Tracer Gecode::Search::Seq::Probe< Tracer >::tracer

protected

Search tracer.

Definition at line 77 of file lds.hh.

## ds

template<class Tracer>

Support::DynamicStack<Node,Heap> Gecode::Search::Seq::Probe< Tracer >::ds

protected

Stack storing current path in search tree

Definition at line 79 of file lds.hh.

## cur

template<class Tracer>

Space* Gecode::Search::Seq::Probe< Tracer >::cur

protected

Current space.

Definition at line 81 of file lds.hh.

## d

template<class Tracer>

unsigned int Gecode::Search::Seq::Probe< Tracer >::d

protected

Current discrepancy.

Definition at line 83 of file lds.hh.

## exhausted

template<class Tracer>

bool Gecode::Search::Seq::Probe< Tracer >::exhausted

protected

Whether entire search space has been exhausted.

Definition at line 85 of file lds.hh.

The documentation for this class was generated from the following files:

- gecode/search/seq/lds.hh
- gecode/search/seq/lds.hpp